rpmds.h File Reference

Structure(s) used for dependency tag sets. More...

`#include <time.h>`
`#include <rpm/rpmtypes.h>`
`#include <rpm/rpmps.h>`
Include dependency graph for rpmds.h:

Go to the source code of this file.

## Macros

#define | RPMSENSE_SENSEMASK 15 /* Mask to get senses, ie serial, */
#define | RPMSENSE_TRIGGER (RPMSENSE_TRIGGERPREIN | RPMSENSE_TRIGGERIN | RPMSENSE_TRIGGERUN | RPMSENSE_TRIGGERPOSTUN)
#define | _ALL_REQUIRES_MASK
#define | _notpre(_x) ((_x) & ~RPMSENSE_PREREQ)
#define | _INSTALL_ONLY_MASK _notpre(RPMSENSE_SCRIPT_PRE|RPMSENSE_SCRIPT_POST|RPMSENSE_RPMLIB|RPMSENSE_KEYRING|RPMSENSE_PRETRANS|RPMSENSE_POSTTRANS)
#define | _ERASE_ONLY_MASK _notpre(RPMSENSE_SCRIPT_PREUN|RPMSENSE_SCRIPT_POSTUN)
#define | isLegacyPreReq(_x) (((_x) & _ALL_REQUIRES_MASK) == RPMSENSE_PREREQ)
#define | isInstallPreReq(_x) ((_x) & _INSTALL_ONLY_MASK)
#define | isErasePreReq(_x) ((_x) & _ERASE_ONLY_MASK)

## Typedefs

typedef rpmFlags | rpmsenseFlags
typedef enum rpmrichOp_e | rpmrichOp
typedef enum rpmrichParseType_e | rpmrichParseType
typedef rpmRC(* | rpmrichParseFunction) (void *cbdata, rpmrichParseType type, const char *n, int nl, const char *e, int el, rpmsenseFlags sense, rpmrichOp op, char **emsg)

## Enumerations

enum

rpmsenseFlags_e {
RPMSENSE_ANY = 0, RPMSENSE_LESS = (1 << 1), RPMSENSE_GREATER = (1 << 2), RPMSENSE_EQUAL = (1 << 3),
RPMSENSE_POSTTRANS = (1 << 5), RPMSENSE_PREREQ = (1 << 6), RPMSENSE_PRETRANS = (1 << 7), RPMSENSE_INTERP = (1 << 8),
RPMSENSE_SCRIPT_PRE = (1 << 9), RPMSENSE_SCRIPT_POST = (1 << 10), RPMSENSE_SCRIPT_PREUN = (1 << 11), RPMSENSE_SCRIPT_POSTUN = (1 << 12),
RPMSENSE_SCRIPT_VERIFY = (1 << 13), RPMSENSE_FIND_REQUIRES = (1 << 14), RPMSENSE_FIND_PROVIDES = (1 << 15), RPMSENSE_TRIGGERIN = (1 << 16),
RPMSENSE_TRIGGERUN = (1 << 17), RPMSENSE_TRIGGERPOSTUN = (1 << 18), RPMSENSE_MISSINGOK = (1 << 19), RPMSENSE_RPMLIB = (1 << 24),
RPMSENSE_TRIGGERPREIN = (1 << 25), RPMSENSE_KEYRING = (1 << 26), RPMSENSE_CONFIG = (1 << 28)
}

| Dependency Attributes. More...
enum | rpmrichOp_e { RPMRICHOP_SINGLE = 1, RPMRICHOP_AND = 2, RPMRICHOP_OR = 3, RPMRICHOP_IF = 4, RPMRICHOP_ELSE = 5 }
enum | rpmrichParseType_e { RPMRICH_PARSE_SIMPLE = 1, RPMRICH_PARSE_ENTER = 2, RPMRICH_PARSE_LEAVE = 3, RPMRICH_PARSE_OP = 4 }

## Functions

rpmsenseFlags | rpmSanitizeDSFlags (rpmTagVal tagN, rpmsenseFlags Flags)
| Return only those flags allowed for given type of dependencies. More...
rpmsenseFlags | rpmParseDSFlags (const char *str, size_t len)
| Convert a string to the sense flags. More...
rpmds | rpmdsLink (rpmds ds)
| Reference a dependency set instance. More...
rpmds | rpmdsFree (rpmds ds)
| Destroy a dependency set. More...
rpmds | rpmdsNew (Header h, rpmTagVal tagN, int flags)
| Create and load a dependency set. More...
char * | rpmdsNewDNEVR (const char *dspfx, const rpmds ds)
| Return new formatted dependency string. More...
rpmds | rpmdsThis (Header h, rpmTagVal tagN, rpmsenseFlags Flags)
| Create, load and initialize a dependency for this header. More...
rpmds | rpmdsSingle (rpmTagVal tagN, const char *N, const char *EVR, rpmsenseFlags Flags)
| Create, load and initialize a dependency set of size 1. More...
rpmds | rpmdsCurrent (rpmds ds)
| Return a new dependency set of size 1 from the current iteration index. More...
int | rpmdsPutToHeader (rpmds ds, Header h)
| Write content of the dependency set to the header. More...
int | rpmdsCount (const rpmds ds)
| Return dependency set count. More...
int | rpmdsIx (const rpmds ds)
| Return dependency set index. More...
int | rpmdsSetIx (rpmds ds, int ix)
| Set dependency set index. More...
const char * | rpmdsDNEVR (const rpmds ds)
| Return current formatted dependency string. More...
char | rpmdsD (const rpmds ds)
| Return one char indicating the type of the dependency. More...
rpmTagVal | rpmdsDToTagN (char deptype)
| Return matching tagN for one char dependency type description. More...
const char * | rpmdsN (const rpmds ds)
| Return current dependency name. More...
const char * | rpmdsEVR (const rpmds ds)
| Return current dependency epoch-version-release. More...
int | rpmdsTi (const rpmds ds)
| Return current dependency triggerindex. More...
rpmsenseFlags | rpmdsFlags (const rpmds ds)
| Return current dependency flags. More...
rpmTagVal | rpmdsTagN (const rpmds ds)
| Return current dependency type. More...
rpmTagVal | rpmdsTagEVR (const rpmds ds)
| Return current dependency type. More...
rpmTagVal | rpmdsTagF (const rpmds ds)
| Return current dependency type. More...
rpmTagVal | rpmdsTagTi (const rpmds ds)
| Return current dependency type. More...
unsigned int | rpmdsInstance (rpmds ds)
| Return dependency header instance, ie whether the dependency comes from an installed header or not. More...
int | rpmdsNoPromote (const rpmds ds)
| Return current "Don't promote Epoch:" flag. More...
int | rpmdsSetNoPromote (rpmds ds, int nopromote)
| Set "Don't promote Epoch:" flag. More...
rpm_color_t | rpmdsColor (const rpmds ds)
| Return current dependency color. More...
rpm_color_t | rpmdsSetColor (const rpmds ds, rpm_color_t color)
| Return current dependency color. More...
void | rpmdsNotify (rpmds ds, const char *where, int rc)
| Notify of results of dependency match. More...
int | rpmdsNext (rpmds ds)
| Return next dependency set iterator index. More...
rpmds | rpmdsInit (rpmds ds)
| Initialize dependency set iterator. More...
int | rpmdsFind (rpmds ds, const rpmds ods)
| Find a dependency set element using binary search. More...
int | rpmdsMerge (rpmds *dsp, rpmds ods)
| Merge a dependency set maintaining (N,EVR,Flags) sorted order. More...
int | rpmdsSearch (rpmds ds, rpmds ods)
| Search a sorted dependency set for an element that overlaps. More...
int | rpmdsCompare (const rpmds A, const rpmds B)
| Compare two versioned dependency ranges, looking for overlap. More...
int | rpmdsAnyMatchesDep (const Header h, const rpmds req, int nopromote)
| Compare package provides dependencies from header with a single dependency. More...
int | rpmdsMatchesDep (const Header h, int ix, const rpmds req, int nopromote)
| Compare package provides dependencies from header with a single dependency. More...
int | rpmdsNVRMatchesDep (const Header h, const rpmds req, int nopromote)
| Compare package name-version-release from header with a single dependency. More...
int | rpmdsRpmlib (rpmds *dsp, const void *tblp)
| Load rpmlib provides into a dependency set. More...
rpmds | rpmdsNewPool (rpmstrPool pool, Header h, rpmTagVal tagN, int flags)
| Create and load a dependency set. More...
rpmds | rpmdsThisPool (rpmstrPool pool, Header h, rpmTagVal tagN, rpmsenseFlags Flags)
| Create, load and initialize a dependency for this header. More...
rpmds | rpmdsSinglePool (rpmstrPool pool, rpmTagVal tagN, const char *N, const char *EVR, rpmsenseFlags Flags)
| Create, load and initialize a dependency set of size 1. More...
rpmds | rpmdsSinglePoolTix (rpmstrPool pool, rpmTagVal tagN, const char *N, const char *EVR, rpmsenseFlags Flags, int triggerIndex)
| Create, load and initialize a trigger dependency set of size 1. More...
int | rpmdsRpmlibPool (rpmstrPool pool, rpmds *dsp, const void *tblp)
| Load rpmlib provides into a dependency set. More...
rpmRC | rpmrichParse (const char **dstrp, char **emsg, rpmrichParseFunction cb, void *cbdata)
| Parse a rich dependency string. More...
int | rpmdsIsRich (rpmds dep)
| Return if current depenency is rich. More...
const char * | rpmrichOpStr (rpmrichOp op)
| Return a string representation of the rich dependency op. More...
rpmRC | rpmdsParseRichDep (rpmds dep, rpmds *leftds, rpmds *rightds, rpmrichOp *op, char **emsg)
| Parse a rich dependency string. More...

## Variables

int | _rpmds_nopromote

## Detailed Description

Structure(s) used for dependency tag sets.

Definition in file rpmds.h.

## Macro Definition Documentation

#define _ALL_REQUIRES_MASK

Value:
(\
RPMSENSE_INTERP | \
RPMSENSE_SCRIPT_PRE | \
RPMSENSE_SCRIPT_POST | \
RPMSENSE_SCRIPT_PREUN | \
RPMSENSE_SCRIPT_POSTUN | \
RPMSENSE_SCRIPT_VERIFY | \
RPMSENSE_FIND_REQUIRES | \
RPMSENSE_RPMLIB | \
RPMSENSE_KEYRING | \
RPMSENSE_PRETRANS | \
RPMSENSE_POSTTRANS | \
RPMSENSE_PREREQ | \
RPMSENSE_MISSINGOK)

Definition at line 63 of file rpmds.h.

#define _ERASE_ONLY_MASK _notpre(RPMSENSE_SCRIPT_PREUN|RPMSENSE_SCRIPT_POSTUN)

Definition at line 81 of file rpmds.h.

#define _INSTALL_ONLY_MASK _notpre(RPMSENSE_SCRIPT_PRE|RPMSENSE_SCRIPT_POST|RPMSENSE_RPMLIB|RPMSENSE_KEYRING|RPMSENSE_PRETRANS|RPMSENSE_POSTTRANS)

Definition at line 79 of file rpmds.h.

#define _notpre | ( |  | _x | ) | ((_x) & ~RPMSENSE_PREREQ)

Definition at line 78 of file rpmds.h.

#define isErasePreReq | ( |  | _x | ) | ((_x) & _ERASE_ONLY_MASK)

Definition at line 86 of file rpmds.h.

#define isInstallPreReq | ( |  | _x | ) | ((_x) & _INSTALL_ONLY_MASK)

Definition at line 85 of file rpmds.h.

#define isLegacyPreReq | ( |  | _x | ) | (((_x) & _ALL_REQUIRES_MASK) == RPMSENSE_PREREQ)

Definition at line 84 of file rpmds.h.

#define RPMSENSE_SENSEMASK 15 /* Mask to get senses, ie serial, */

Definition at line 57 of file rpmds.h.

#define RPMSENSE_TRIGGER (RPMSENSE_TRIGGERPREIN | RPMSENSE_TRIGGERIN | RPMSENSE_TRIGGERUN | RPMSENSE_TRIGGERPOSTUN)

Definition at line 60 of file rpmds.h.

## Typedef Documentation

typedef enum rpmrichOp_e rpmrichOp

typedef rpmRC(* rpmrichParseFunction) (void *cbdata, rpmrichParseType type, const char *n, int nl, const char *e, int el, rpmsenseFlags sense, rpmrichOp op, char **emsg)

Definition at line 481 of file rpmds.h.

typedef enum rpmrichParseType_e rpmrichParseType

typedef rpmFlags rpmsenseFlags

Definition at line 55 of file rpmds.h.

## Enumeration Type Documentation

enum rpmrichOp_e

Enumerator
RPMRICHOP_SINGLE |
RPMRICHOP_AND |
RPMRICHOP_OR |
RPMRICHOP_IF |
RPMRICHOP_ELSE |

Definition at line 466 of file rpmds.h.

enum rpmrichParseType_e

Enumerator
RPMRICH_PARSE_SIMPLE |
RPMRICH_PARSE_ENTER |
RPMRICH_PARSE_LEAVE |
RPMRICH_PARSE_OP |

Definition at line 474 of file rpmds.h.

enum rpmsenseFlags_e

Dependency Attributes.

Enumerator
RPMSENSE_ANY |
RPMSENSE_LESS |
RPMSENSE_GREATER |
RPMSENSE_EQUAL |
RPMSENSE_POSTTRANS | posttrans dependency
RPMSENSE_PREREQ |
RPMSENSE_PRETRANS | Pre-transaction dependency.
RPMSENSE_INTERP | Interpreter used by scriptlet.
RPMSENSE_SCRIPT_PRE | pre dependency.
RPMSENSE_SCRIPT_POST | post dependency.
RPMSENSE_SCRIPT_PREUN | preun dependency.
RPMSENSE_SCRIPT_POSTUN | postun dependency.
RPMSENSE_SCRIPT_VERIFY | verify dependency.
RPMSENSE_FIND_REQUIRES | find-requires generated dependency.
RPMSENSE_FIND_PROVIDES | find-provides generated dependency.
RPMSENSE_TRIGGERIN | triggerin dependency.
RPMSENSE_TRIGGERUN | triggerun dependency.
RPMSENSE_TRIGGERPOSTUN | triggerpostun dependency.
RPMSENSE_MISSINGOK | suggests/enhances hint.
RPMSENSE_RPMLIB | rpmlib(feature) dependency.
RPMSENSE_TRIGGERPREIN | triggerprein dependency.
RPMSENSE_KEYRING |
RPMSENSE_CONFIG |

Definition at line 25 of file rpmds.h.

## Function Documentation

int rpmdsAnyMatchesDep | ( | const Header | h,
|  | const rpmds | req,
|  | int | nopromote
| ) |  |

Compare package provides dependencies from header with a single dependency.

Parameters

  h | header
  req | dependency set
  nopromote | Don't promote Epoch: in comparison?

Returns
  1 if any dependency overlaps, 0 otherwise

rpm_color_t rpmdsColor | ( | const rpmds | ds | ) |

Return current dependency color.

Parameters

  ds | dependency set

Returns
  current dependency color

int rpmdsCompare | ( | const rpmds | A,
|  | const rpmds | B
| ) |  |

Compare two versioned dependency ranges, looking for overlap.

Parameters

  A | 1st dependency
  B | 2nd dependency

Returns
  1 if dependencies overlap, 0 otherwise

int rpmdsCount | ( | const rpmds | ds | ) |

Return dependency set count.

Parameters

  ds | dependency set

Returns
  current count

rpmds rpmdsCurrent | ( | rpmds | ds | ) |

Return a new dependency set of size 1 from the current iteration index.

Parameters

  ds | dependency set

Returns
  new dependency set

char rpmdsD | ( | const rpmds | ds | ) |

Return one char indicating the type of the dependency.

Parameters

  ds | dependency set

Returns
  character

const char* rpmdsDNEVR | ( | const rpmds | ds | ) |

Return current formatted dependency string.

Parameters

  ds | dependency set

Returns
  current dependency DNEVR, NULL on invalid

rpmTagVal rpmdsDToTagN | ( | char | deptype | ) |

Return matching tagN for one char dependency type description.

Parameters

  deptype | character

Returns
  type of dependency

const char* rpmdsEVR | ( | const rpmds | ds | ) |

Return current dependency epoch-version-release.

Parameters

  ds | dependency set

Returns
  current dependency EVR, NULL on invalid

int rpmdsFind | ( | rpmds | ds,
|  | const rpmds | ods
| ) |  |

Find a dependency set element using binary search.

Parameters

  ds | dependency set to search
  ods | dependency set element to find.

Returns
  dependency index (or -1 if not found)

rpmsenseFlags rpmdsFlags | ( | const rpmds | ds | ) |

Return current dependency flags.

Parameters

  ds | dependency set

Returns
  current dependency flags, 0 on invalid

rpmds rpmdsFree | ( | rpmds | ds | ) |

Destroy a dependency set.

Parameters

  ds | dependency set

Returns
  NULL always

rpmds rpmdsInit | ( | rpmds | ds | ) |

Initialize dependency set iterator.

Parameters

  ds | dependency set

Returns
  dependency set

unsigned int rpmdsInstance | ( | rpmds | ds | ) |

Return dependency header instance, ie whether the dependency comes from an installed header or not.

Parameters

  ds | dependency set

Returns
  header instance of dependency (0 for not installed)

int rpmdsIsRich | ( | rpmds | dep | ) |

Return if current depenency is rich.

Parameters

  dep | the dependency

Returns
  1 is dependency is a rich 0 otherwise

int rpmdsIx | ( | const rpmds | ds | ) |

Return dependency set index.

Parameters

  ds | dependency set

Returns
  current index

rpmds rpmdsLink | ( | rpmds | ds | ) |

Reference a dependency set instance.

Parameters

  ds | dependency set

Returns
  new dependency set reference

int rpmdsMatchesDep | ( | const Header | h,
|  | int | ix,
|  | const rpmds | req,
|  | int | nopromote
| ) |  |

Compare package provides dependencies from header with a single dependency.

Parameters

  h | header
  ix | index in header provides
  req | dependency set
  nopromote | Don't promote Epoch: in comparison?

Returns
  1 if any dependency overlaps, 0 otherwise

int rpmdsMerge | ( | rpmds * | dsp,
|  | rpmds | ods
| ) |  |

Merge a dependency set maintaining (N,EVR,Flags) sorted order.

Return values

  *dsp | (merged) dependency set

Parameters

  ods | dependency set to merge

Returns
  number of merged dependencies, -1 on error

const char* rpmdsN | ( | const rpmds | ds | ) |

Return current dependency name.

Parameters

  ds | dependency set

Returns
  current dependency name, NULL on invalid

rpmds rpmdsNew | ( | Header | h,
|  | rpmTagVal | tagN,
|  | int | flags
| ) |  |

Create and load a dependency set.

Parameters

  h | header
  tagN | type of dependency
  flags | unused

Returns
  new dependency set

char* rpmdsNewDNEVR | ( | const char * | dspfx,
|  | const rpmds | ds
| ) |  |

Return new formatted dependency string.

Parameters

  dspfx | formatted dependency string prefix
  ds | dependency set

Returns
  new formatted dependency (malloc'ed)

rpmds rpmdsNewPool | ( | rpmstrPool | pool,
|  | Header | h,
|  | rpmTagVal | tagN,
|  | int | flags
| ) |  |

Create and load a dependency set.

Parameters

  pool | shared string pool (or NULL for private pool)
  h | header
  tagN | type of dependency
  flags | unused

Returns
  new dependency set

int rpmdsNext | ( | rpmds | ds | ) |

Return next dependency set iterator index.

Parameters

  ds | dependency set

Returns
  dependency set iterator index, -1 on termination

int rpmdsNoPromote | ( | const rpmds | ds | ) |

Return current "Don't promote Epoch:" flag.

This flag controls for Epoch: promotion when a dependency set is compared. If the flag is set (for already installed packages), then an unspecified value will be treated as Epoch: 0. Otherwise (for added packages), the Epoch: portion of the comparison is skipped if the value is not specified, i.e. an unspecified Epoch: is assumed to be equal in dependency comparisons.

Parameters

  ds | dependency set

Returns
  current "Don't promote Epoch:" flag

void rpmdsNotify | ( | rpmds | ds,
|  | const char * | where,
|  | int | rc
| ) |  |

Notify of results of dependency match.

Parameters

  ds | dependency set
  where | where dependency was resolved (or NULL)
  rc | 0 == YES, otherwise NO

int rpmdsNVRMatchesDep | ( | const Header | h,
|  | const rpmds | req,
|  | int | nopromote
| ) |  |

Compare package name-version-release from header with a single dependency.

Parameters

  h | header
  req | dependency set
  nopromote | Don't promote Epoch: in comparison?

Returns
  1 if dependency overlaps, 0 otherwise

rpmRC rpmdsParseRichDep | ( | rpmds | dep,
|  | rpmds * | leftds,
|  | rpmds * | rightds,
|  | rpmrichOp * | op,
|  | char ** | emsg
| ) |  |

Parse a rich dependency string.

Parameters

  dep | the dependency
  leftds | returns the left dependency
  rightds | returns the right dependency
  op | returns the rich dep op
  emsg | returns the error string

Returns
  RPMRC_OK on success

int rpmdsPutToHeader | ( | rpmds | ds,
|  | Header | h
| ) |  |

Write content of the dependency set to the header.

Parameters

  ds | dependency set
  h | header

Returns
  0 on success

int rpmdsRpmlib | ( | rpmds * | dsp,
|  | const void * | tblp
| ) |  |

Load rpmlib provides into a dependency set.

Return values

  *dsp | (loaded) depedency set

Parameters

  tblp | rpmlib provides table (NULL uses internal table)

Returns
  0 on success

int rpmdsRpmlibPool | ( | rpmstrPool | pool,
|  | rpmds * | dsp,
|  | const void * | tblp
| ) |  |

Load rpmlib provides into a dependency set.

Parameters

  pool | shared string pool (or NULL for private pool)

Return values

  *dsp | (loaded) depedency set

Parameters

  tblp | rpmlib provides table (NULL uses internal table)

Returns
  0 on success

int rpmdsSearch | ( | rpmds | ds,
|  | rpmds | ods
| ) |  |

Search a sorted dependency set for an element that overlaps.

A boolean result is saved (if allocated) and accessible through rpmdsResult(ods) afterwards.

Parameters

  ds | dependency set to search
  ods | dependency set element to find.

Returns
  dependency index (or -1 if not found)

rpm_color_t rpmdsSetColor | ( | const rpmds | ds,
|  | rpm_color_t | color
| ) |  |

Return current dependency color.

Parameters

  ds | dependency set
  color | new dependency color

Returns
  previous dependency color

int rpmdsSetIx | ( | rpmds | ds,
|  | int | ix
| ) |  |

Set dependency set index.

Parameters

  ds | dependency set
  ix | new index

Returns
  current index

int rpmdsSetNoPromote | ( | rpmds | ds,
|  | int | nopromote
| ) |  |

Set "Don't promote Epoch:" flag.

Parameters

  ds | dependency set
  nopromote | Should an unspecified Epoch: be treated as Epoch: 0?

Returns
  previous "Don't promote Epoch:" flag

rpmds rpmdsSingle | ( | rpmTagVal | tagN,
|  | const char * | N,
|  | const char * | EVR,
|  | rpmsenseFlags | Flags
| ) |  |

Create, load and initialize a dependency set of size 1.

Parameters

  tagN | type of dependency
  N | name
  EVR | epoch:version-release
  Flags | comparison flags

Returns
  new dependency set

rpmds rpmdsSinglePool | ( | rpmstrPool | pool,
|  | rpmTagVal | tagN,
|  | const char * | N,
|  | const char * | EVR,
|  | rpmsenseFlags | Flags
| ) |  |

Create, load and initialize a dependency set of size 1.

Parameters

  pool | string pool (or NULL for private pool)
  tagN | type of dependency
  N | name
  EVR | epoch:version-release
  Flags | comparison flags

Returns
  new dependency set

rpmds rpmdsSinglePoolTix | ( | rpmstrPool | pool,
|  | rpmTagVal | tagN,
|  | const char * | N,
|  | const char * | EVR,
|  | rpmsenseFlags | Flags,
|  | int | triggerIndex
| ) |  |

Create, load and initialize a trigger dependency set of size 1.

Parameters

  pool | string pool (or NULL for private pool)
  tagN | type of dependency
  N | name
  EVR | epoch:version-release
  Flags | comparison flags
  triggerIndex | trigger index

Returns
  new dependency set

rpmTagVal rpmdsTagEVR | ( | const rpmds | ds | ) |

Return current dependency type.

Parameters

  ds | dependency set

Returns
  current dependency type version tag, 0 on invalid

rpmTagVal rpmdsTagF | ( | const rpmds | ds | ) |

Return current dependency type.

Parameters

  ds | dependency set

Returns
  current dependency type flags tag, 0 on invalid

rpmTagVal rpmdsTagN | ( | const rpmds | ds | ) |

Return current dependency type.

Parameters

  ds | dependency set

Returns
  current dependency type, 0 on invalid

rpmTagVal rpmdsTagTi | ( | const rpmds | ds | ) |

Return current dependency type.

Parameters

  ds | dependency set

Returns
  current dependency type trigger index tag, 0 on invalid

rpmds rpmdsThis | ( | Header | h,
|  | rpmTagVal | tagN,
|  | rpmsenseFlags | Flags
| ) |  |

Create, load and initialize a dependency for this header.

Parameters

  h | header
  tagN | type of dependency
  Flags | comparison flags

Returns
  new dependency set

rpmds rpmdsThisPool | ( | rpmstrPool | pool,
|  | Header | h,
|  | rpmTagVal | tagN,
|  | rpmsenseFlags | Flags
| ) |  |

Create, load and initialize a dependency for this header.

Parameters

  pool | string pool (or NULL for private pool)
  h | header
  tagN | type of dependency
  Flags | comparison flags

Returns
  new dependency set

int rpmdsTi | ( | const rpmds | ds | ) |

Return current dependency triggerindex.

Parameters

  ds | dependency set

Returns
  current dependency trigger index, 0 on invalid

rpmsenseFlags rpmParseDSFlags | ( | const char * | str,
|  | size_t | len
| ) |  |

Convert a string to the sense flags.

Parameters

  str | the string
  len | length of the string

Returns
  flags, zero for unknwon relations

const char* rpmrichOpStr | ( | rpmrichOp | op | ) |

Return a string representation of the rich dependency op.

Parameters

  op | the dependency op

Returns
  constant string, do not free

rpmRC rpmrichParse | ( | const char ** | dstrp,
|  | char ** | emsg,
|  | rpmrichParseFunction | cb,
|  | void * | cbdata
| ) |  |

Parse a rich dependency string.

Parameters

  dstrp | pointer to sting, will be updated
  emsg | returns the error string, can be NULL
  cb | callback function
  cbdata | callback function data

Returns
  RPMRC_OK on success

rpmsenseFlags rpmSanitizeDSFlags | ( | rpmTagVal | tagN,
|  | rpmsenseFlags | Flags
| ) |  |

Return only those flags allowed for given type of dependencies.

Parameters

  tagN | type of dependency
  Flags | flags

Returns
  flags filtered to allowed bits

## Variable Documentation

int _rpmds_nopromote